Index: /trunk/SophyaLib/HiStats/ntupintf.cc
===================================================================
--- /trunk/SophyaLib/HiStats/ntupintf.cc	(revision 2681)
+++ /trunk/SophyaLib/HiStats/ntupintf.cc	(revision 2682)
@@ -4,4 +4,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include "pexceptions.h"
 
 /*!
@@ -73,5 +74,5 @@
 //! Retuns the number of lines (rows) of the data set
 /* --Methode-- */
-uint_4 NTupleInterface::NbLines() const
+sa_size_t NTupleInterface::NbLines() const
 {
 return(0);
@@ -80,5 +81,5 @@
 //! Retuns the number of columns of the data set 
 /* --Methode-- */
-uint_4 NTupleInterface::NbColumns() const
+sa_size_t NTupleInterface::NbColumns() const
 {
 return(0);
@@ -91,7 +92,7 @@
 */
 /* --Methode-- */
-r_8 * NTupleInterface::GetLineD(int ) const
+r_8 * NTupleInterface::GetLineD(sa_size_t ) const
 {
-return(NULL);
+  throw NotAvailableOperation("NTupleInterface::GetLineD(sa_size_t ) must be redefined in derived classes");
 }
 
@@ -102,5 +103,5 @@
 */
 /* --Methode-- */
-r_8 NTupleInterface::GetCell(int , int ) const
+r_8 NTupleInterface::GetCell(sa_size_t , sa_size_t ) const
 {
 return(0.);
@@ -113,5 +114,5 @@
 */
 /* --Methode-- */
-r_8 NTupleInterface::GetCell(int n, string const & nom) const
+r_8 NTupleInterface::GetCell(sa_size_t n, string const & nom) const
 {
 return(GetCell(n, ColumnIndex(nom)));
@@ -123,5 +124,5 @@
     converted to a string.
 */
-string NTupleInterface::GetCelltoString(int n, int k) const
+string NTupleInterface::GetCelltoString(sa_size_t n, sa_size_t k) const
 {
 char strg[64];
@@ -136,5 +137,5 @@
     converted to a string.
 */
-string NTupleInterface::GetCelltoString(int n, string const & nom) const
+string NTupleInterface::GetCelltoString(sa_size_t n, string const & nom) const
 {
 return(GetCelltoString(n, ColumnIndex(nom)));
@@ -143,5 +144,5 @@
 //! Returns the minimum and maximum values for a given column
 /* --Methode-- */
-void NTupleInterface::GetMinMax(int , double& min, double& max)   const
+void NTupleInterface::GetMinMax(sa_size_t , double& min, double& max)   const
 {
 min = max = 0.;
@@ -150,12 +151,12 @@
 /* --Methode-- */
 //! Returns the minimum and maximum values for a given named column
-void NTupleInterface::GetMinMax(string const & , double& min, double& max)   const
+void NTupleInterface::GetMinMax(string const & nom, double& min, double& max)   const
 {
-min = max = 0.;
+  GetMinMax(ColumnIndex(nom), min, max);
 }
 
 /* --Methode-- */
 //! Returns the column index given the column name
-int NTupleInterface::ColumnIndex(string const & nom)  const
+sa_size_t NTupleInterface::ColumnIndex(string const & nom)  const
 {
 return(-1);
@@ -164,5 +165,5 @@
 /* --Methode-- */
 //! Returns the column name corresponding to a column index.
-string NTupleInterface::ColumnName(int k) const
+string NTupleInterface::ColumnName(sa_size_t k) const
 {
 return("");
@@ -182,5 +183,5 @@
 
 /* --Methode-- */
-string NTupleInterface::LineToString(int ) const
+string NTupleInterface::LineToString(sa_size_t ) const
 {
 return("");
Index: /trunk/SophyaLib/HiStats/ntupintf.h
===================================================================
--- /trunk/SophyaLib/HiStats/ntupintf.h	(revision 2681)
+++ /trunk/SophyaLib/HiStats/ntupintf.h	(revision 2682)
@@ -16,25 +16,25 @@
   virtual		~NTupleInterface();
 // Nombre de lignes du NTuple  (Nb d'entrees)  
-  virtual uint_4        NbLines() const ;
+  virtual sa_size_t     NbLines() const ;
 // Nombre de colonnes (nb de variables)
-  virtual uint_4        NbColumns() const ;
+  virtual sa_size_t     NbColumns() const ;
 // La ligne numero n, sous forme d'un tableau de double
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
 // Cellule de la ligne n, colonne k
-  virtual r_8		GetCell(int n, int k) const ;
+  virtual r_8		GetCell(sa_size_t n, sa_size_t k) const ;
 // Cellule de la ligne n, colonne nom
-  virtual r_8		GetCell(int n, string const & nom) const ;
+  virtual r_8		GetCell(sa_size_t n, string const & nom) const ;
 // Cellule de la ligne n, colonne k, converti en chaine de caracteres
-  virtual string	GetCelltoString(int n, int k) const ;
+  virtual string	GetCelltoString(sa_size_t n, sa_size_t k) const ;
 // Cellule de la ligne n, colonne nom, converti en chaine de caracteres
-  virtual string	GetCelltoString(int n, string const & nom) const ;
+  virtual string	GetCelltoString(sa_size_t n, string const & nom) const ;
 // Min et Max pour la colonne k
-  virtual void		GetMinMax(int k, double& min, double& max)   const ; 
+  virtual void		GetMinMax(sa_size_t k, double& min, double& max)   const ; 
 // Min et Max pour la colonne nom
   virtual void		GetMinMax(string const & nom, double& min, double& max)   const ;
 // Numero de colonne pour nom 
-  virtual int           ColumnIndex(string const & nom)  const ;
+  virtual sa_size_t     ColumnIndex(string const & nom)  const ;
 // Nom de colonne numero k
-  virtual string        ColumnName(int k) const;
+  virtual string        ColumnName(sa_size_t k) const;
 // Declaration des variables style C
   virtual string	VarList_C(const char* nomx=NULL) const ;
@@ -42,5 +42,5 @@
   virtual string        LineHeaderToString() const;
 // Contenu de la ligne n, pouvant servir a l'impression
-  virtual string        LineToString(int n) const;  
+  virtual string        LineToString(sa_size_t n) const;  
 };
 
Index: /trunk/SophyaLib/HiStats/ntuple.cc
===================================================================
--- /trunk/SophyaLib/HiStats/ntuple.cc	(revision 2681)
+++ /trunk/SophyaLib/HiStats/ntuple.cc	(revision 2682)
@@ -526,10 +526,10 @@
 
 /* --Methode-- */
-uint_4 NTuple::NbLines() const
+sa_size_t NTuple::NbLines() const
 {
 return(NEntry());
 }
 /* --Methode-- */
-uint_4 NTuple::NbColumns() const
+sa_size_t NTuple::NbColumns() const
 {
 return(NVar());
@@ -537,5 +537,5 @@
 
 /* --Methode-- */
-r_8 * NTuple::GetLineD(int n) const
+r_8 * NTuple::GetLineD(sa_size_t n) const
 {
 return(GetVecD(n));
@@ -543,5 +543,5 @@
 
 /* --Methode-- */
-r_8 NTuple::GetCell(int n, int k) const
+r_8 NTuple::GetCell(sa_size_t n, sa_size_t k) const
 {
 return(GetVal(n, k));
@@ -549,5 +549,5 @@
 
 /* --Methode-- */
-r_8 NTuple::GetCell(int n, string const & nom) const
+r_8 NTuple::GetCell(sa_size_t n, string const & nom) const
 {
 return(GetVal(n, nom.c_str()));
@@ -556,5 +556,5 @@
 /* --Methode-- */
 //++
-void  NTuple::GetMinMax(int k, double& min, double& max)  const
+void  NTuple::GetMinMax(sa_size_t k, double& min, double& max)  const
 //
 //	Retourne le minimum et le maximum de la variable `k'.
@@ -585,5 +585,5 @@
 
 /* --Methode-- */
-int NTuple::ColumnIndex(string const & nom)  const
+sa_size_t NTuple::ColumnIndex(string const & nom)  const
 {
 return(IndexNom(nom.c_str()));
@@ -591,5 +591,5 @@
 
 /* --Methode-- */
-string NTuple::ColumnName(int k) const
+string NTuple::ColumnName(sa_size_t k) const
 {
 return(NomIndex(k));
@@ -646,5 +646,5 @@
 /* --Methode-- */
 //++
-string NTuple::LineToString(int n) const
+string NTuple::LineToString(sa_size_t n) const
 //	Retourne une chaine de caracteres avec le contenu de la ligne "n"
 //	utilisable pour une impression
Index: /trunk/SophyaLib/HiStats/ntuple.h
===================================================================
--- /trunk/SophyaLib/HiStats/ntuple.h	(revision 2681)
+++ /trunk/SophyaLib/HiStats/ntuple.h	(revision 2682)
@@ -62,16 +62,16 @@
 
 // Declaration de l interface NTuple
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
-  virtual r_8		GetCell(int n, int k) const ;
-  virtual r_8		GetCell(int n, string const & nom) const ;
-  virtual void		GetMinMax(int k, double& min, double& max)   const ; 
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
+  virtual r_8		GetCell(sa_size_t n, sa_size_t k) const ;
+  virtual r_8		GetCell(sa_size_t n, string const & nom) const ;
+  virtual void		GetMinMax(sa_size_t k, double& min, double& max)   const ; 
   virtual void		GetMinMax(string const & nom, double& min, double& max)   const ; 
-  virtual int           ColumnIndex(string const & nom)  const ;
-  virtual string        ColumnName(int k) const;
+  virtual sa_size_t     ColumnIndex(string const & nom)  const ;
+  virtual string        ColumnName(sa_size_t k) const;
   virtual string	VarList_C(const char* nomx=NULL) const ;
   virtual string        LineHeaderToString() const;
-  virtual string        LineToString(int n) const;  
+  virtual string        LineToString(sa_size_t n) const;  
 
 //  Pour la gestion de persistance
Index: /trunk/SophyaLib/HiStats/xntuple.cc
===================================================================
--- /trunk/SophyaLib/HiStats/xntuple.cc	(revision 2681)
+++ /trunk/SophyaLib/HiStats/xntuple.cc	(revision 2682)
@@ -718,15 +718,15 @@
 // 
 // 
-uint_4 XNTuple::NbLines() const
+sa_size_t XNTuple::NbLines() const
 {
     return(NEntry());
 }
 
-uint_4 XNTuple::NbColumns() const
+sa_size_t XNTuple::NbColumns() const
 {
     return(NVar());
 }
 
-r_8* XNTuple::GetLineD(int n) const 
+r_8* XNTuple::GetLineD(sa_size_t n) const 
 {
     // memcpy() impossible
@@ -745,5 +745,5 @@
 
 
-r_8  XNTuple::GetCell(int n, int k) const 
+r_8  XNTuple::GetCell(sa_size_t n, sa_size_t k) const 
 {
     if( k<0 || k>=(mD+mF+mI+mS) ) return BADVAL ; 
@@ -756,5 +756,5 @@
 
 
-r_8  XNTuple::GetCell(int n, string const& nom) const 
+r_8  XNTuple::GetCell(sa_size_t n, string const& nom) const 
 {
     int k = IndexNom(nom.c_str()) ; 
@@ -767,5 +767,5 @@
 }
 
-string   XNTuple::GetCelltoString(int n, int k) const
+string   XNTuple::GetCelltoString(sa_size_t n, sa_size_t k) const
 {
     char buff[32];
@@ -782,5 +782,5 @@
 }
 
-void XNTuple::GetMinMax(int k, double& min, double& max)  const
+void XNTuple::GetMinMax(sa_size_t k, double& min, double& max)  const
 {
     min = 9E19 ; max = -9E19 ; 
@@ -800,5 +800,5 @@
 
 
-int XNTuple::ColumnIndex(string const& nom) const 
+sa_size_t XNTuple::ColumnIndex(string const& nom) const 
 {
     return IndexNom(nom.c_str()) ; 
@@ -806,5 +806,5 @@
 
 
-string XNTuple::ColumnName(int k) const 
+string XNTuple::ColumnName(sa_size_t k) const 
 {
     return NomIndex(k) ; 
@@ -882,5 +882,5 @@
 
 
-string XNTuple::LineToString(int n) const 
+string XNTuple::LineToString(sa_size_t n) const 
 {
     char buff[32];
Index: /trunk/SophyaLib/HiStats/xntuple.h
===================================================================
--- /trunk/SophyaLib/HiStats/xntuple.h	(revision 2681)
+++ /trunk/SophyaLib/HiStats/xntuple.h	(revision 2682)
@@ -91,17 +91,17 @@
     
 // Declaration de l interface NTuple
-    virtual uint_4    NbLines() const ;
-    virtual uint_4    NbColumns() const ;
-    virtual r_8 *     GetLineD(int n) const ;
-    virtual r_8	      GetCell(int n, int k) const ;
-    virtual r_8	      GetCell(int n, string const & nom) const ;
-    virtual string    GetCelltoString(int n, int k) const ;
-    virtual void      GetMinMax(int k, double& min, double& max)   const ; 
+    virtual sa_size_t NbLines() const ;
+    virtual sa_size_t NbColumns() const ;
+    virtual r_8 *     GetLineD(sa_size_t n) const ;
+    virtual r_8	      GetCell(sa_size_t n, sa_size_t k) const ;
+    virtual r_8	      GetCell(sa_size_t n, string const & nom) const ;
+    virtual string    GetCelltoString(sa_size_t n, sa_size_t k) const ;
+    virtual void      GetMinMax(sa_size_t k, double& min, double& max)   const ; 
     virtual void      GetMinMax(string const & nom, double& min, double& max)   const ; 
-    virtual int       ColumnIndex(string const & nom)  const ;
-    virtual string    ColumnName(int k) const;
+    virtual sa_size_t ColumnIndex(string const & nom)  const ;
+    virtual string    ColumnName(sa_size_t k) const;
     virtual string    VarList_C(const char* nomx=NULL) const ;
     virtual string    LineHeaderToString() const;
-    virtual string    LineToString(int n) const;  
+    virtual string    LineToString(sa_size_t n) const;  
 
 //  Pour la gestion de persistance