Index: /trunk/SophyaExt/FitsIOServer/fbtntintf.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fbtntintf.cc	(revision 2682)
+++ /trunk/SophyaExt/FitsIOServer/fbtntintf.cc	(revision 2683)
@@ -183,15 +183,15 @@
 
 /////////////////////////////////////////////////
-uint_4 FitsBTNtuIntf::NbLines() const
+sa_size_t FitsBTNtuIntf::NbLines() const
 {
  return NBline;
 }
 
-uint_4 FitsBTNtuIntf::NbColumns() const
+sa_size_t FitsBTNtuIntf::NbColumns() const
 {
  return NBcol;
 }
 
-r_8 * FitsBTNtuIntf::GetLineD(int n) const
+r_8 * FitsBTNtuIntf::GetLineD(sa_size_t n) const
 // Attention: n [0,NBline[, cfistio veut [1,NBline]
 {
@@ -248,5 +248,5 @@
 }
 
-r_8 FitsBTNtuIntf::GetCell(int n, int k) const
+r_8 FitsBTNtuIntf::GetCell(sa_size_t n, sa_size_t k) const
 {
  if(n<0 || n>=NBline || k<0 || k>=NBcol) return 0.;
Index: /trunk/SophyaExt/FitsIOServer/fbtntintf.h
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fbtntintf.h	(revision 2682)
+++ /trunk/SophyaExt/FitsIOServer/fbtntintf.h	(revision 2683)
@@ -29,8 +29,8 @@
   inline  void Print(int lp=1) const {Print(cout,lp);}
 
-  virtual uint_4 NbLines() const ;
-  virtual uint_4 NbColumns() const ;
-  virtual r_8 * GetLineD(int n) const ;
-  virtual r_8 GetCell(int n, int k) const ;
+  virtual sa_size_t NbLines() const ;
+  virtual sa_size_t NbColumns() const ;
+  virtual r_8 * GetLineD(sa_size_t  n) const ;
+  virtual r_8 GetCell( sa_size_t n, sa_size_t  k) const ;
   virtual string VarList_C(const char* nomx=NULL) const ;
 
Index: /trunk/SophyaLib/NTools/generaldata.cc
===================================================================
--- /trunk/SophyaLib/NTools/generaldata.cc	(revision 2682)
+++ /trunk/SophyaLib/NTools/generaldata.cc	(revision 2683)
@@ -869,5 +869,5 @@
   Retourne le nombre de ligne = NData() (pour interface NTuple)
 */
-uint_4 GeneralFitData::NbLines() const
+sa_size_t GeneralFitData::NbLines() const
 {
 return(NData());
@@ -886,5 +886,5 @@
   (pour interface NTuple)
 */
-uint_4 GeneralFitData::NbColumns() const
+sa_size_t GeneralFitData::NbColumns() const
 {
 return(2*NVar()+3);
@@ -892,5 +892,5 @@
 
 //! Pour interface NTuple
-r_8 * GeneralFitData::GetLineD(int n) const
+r_8 * GeneralFitData::GetLineD(sa_size_t n) const
 {
 return(GetVec(n,NULL));
@@ -898,5 +898,5 @@
 
 //! Pour interface NTuple
-r_8 GeneralFitData::GetCell(int n, int k) const
+r_8 GeneralFitData::GetCell(sa_size_t n, sa_size_t k) const
 {
 if(k<0 || k>=2*NVar()+3) return 0.;
@@ -906,7 +906,7 @@
 
 //! Pour interface NTuple
-r_8 GeneralFitData::GetCell(int n, string const & nom) const
-{
-int k = ColumnIndex(nom);
+r_8 GeneralFitData::GetCell(sa_size_t n, string const & nom) const
+{
+sa_size_t k = ColumnIndex(nom);
 return(GetCell(n,k));
 }
@@ -915,5 +915,5 @@
   Retourne le minimum et le maximum de la variable `k' (pour interface NTuple).
 */
-void GeneralFitData::GetMinMax(int k, double& min, double& max)  const
+void GeneralFitData::GetMinMax(sa_size_t k, double& min, double& max)  const
 {
 int var;
@@ -931,10 +931,10 @@
 void GeneralFitData::GetMinMax(string const & nom, double& min, double& max)   const
 {
-int k = ColumnIndex(nom);
+sa_size_t k = ColumnIndex(nom);
 GetMinMax(k,min,max);
 }
 
 //! Pour interface NTuple
-int GeneralFitData::ColumnIndex(string const & nom)  const
+sa_size_t GeneralFitData::ColumnIndex(string const & nom)  const
 {
 char str[64]; int k = -1;
@@ -950,5 +950,5 @@
 
 //! Pour interface NTuple
-string GeneralFitData::ColumnName(int k) const
+string GeneralFitData::ColumnName(sa_size_t k) const
 {
 if(k==2*NVar())                return string("y");
Index: /trunk/SophyaLib/NTools/generaldata.h
===================================================================
--- /trunk/SophyaLib/NTools/generaldata.h	(revision 2682)
+++ /trunk/SophyaLib/NTools/generaldata.h	(revision 2683)
@@ -145,13 +145,13 @@
 
 // Declaration de l interface NTuple
-  virtual uint_4        NbLines() const;
-  virtual uint_4        NbColumns() const;
-  virtual r_8 *         GetLineD(int n) const;
-  virtual r_8		GetCell(int n, int k) const;
-  virtual r_8		GetCell(int n, string const & nom) const;
-  virtual void		GetMinMax(int k, double& min, double& max) const; 
+  virtual sa_size_t     NbLines() const;
+  virtual sa_size_t     NbColumns() const;
+  virtual r_8 *         GetLineD(sa_size_t n) const;
+  virtual r_8		GetCell(sa_size_t n, sa_size_t k) const;
+  virtual r_8		GetCell(sa_size_t n, string const & nom) const;
+  virtual void		GetMinMax(sa_size_t k, double& min, double& max) const; 
   virtual void		GetMinMax(string const & nom, double& min, double& max) const;
-  virtual int           ColumnIndex(string const & nom) const;
-  virtual string        ColumnName(int k) const;
+  virtual sa_size_t     ColumnIndex(string const & nom) const;
+  virtual string        ColumnName(sa_size_t k) const;
   virtual string	VarList_C(const char* nomx=NULL) const;
 
Index: /trunk/SophyaPI/PIext/nomhistadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 2683)
@@ -187,5 +187,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Histo::NbLines() const 
+sa_size_t NTupInt_Histo::NbLines() const 
 {
 return(mHis->NBins());
@@ -193,5 +193,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Histo::NbColumns() const
+sa_size_t NTupInt_Histo::NbColumns() const
 {
 return(4);
@@ -199,5 +199,5 @@
 
 /* --Methode-- */
-r_8* NTupInt_Histo::GetLineD(int k) const
+r_8* NTupInt_Histo::GetLineD(sa_size_t k) const
 {
 int i;
@@ -368,5 +368,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Histo2D::NbLines() const 
+sa_size_t NTupInt_Histo2D::NbLines() const 
 {
 return(mHis->NBinX()*mHis->NBinY());
@@ -374,5 +374,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Histo2D::NbColumns() const 
+sa_size_t NTupInt_Histo2D::NbColumns() const 
 {
 return(6);
@@ -380,5 +380,5 @@
 
 /* --Methode-- */
-r_8* NTupInt_Histo2D::GetLineD(int n) const
+r_8* NTupInt_Histo2D::GetLineD(sa_size_t n) const
 {
 int i,j;
Index: /trunk/SophyaPI/PIext/nomhistadapter.h
===================================================================
--- /trunk/SophyaPI/PIext/nomhistadapter.h	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomhistadapter.h	(revision 2683)
@@ -57,7 +57,7 @@
 			NTupInt_Histo(Histo* h);
   virtual		~NTupInt_Histo();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
@@ -106,7 +106,7 @@
 			NTupInt_Histo2D(Histo2D* h);
   virtual		~NTupInt_Histo2D();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
Index: /trunk/SophyaPI/PIext/nomimagadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomimagadapter.cc	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomimagadapter.cc	(revision 2683)
@@ -228,5 +228,5 @@
 /* --Methode-- */
 template <class T>
-uint_4 NTupInt_Image<T>::NbLines() const 
+sa_size_t NTupInt_Image<T>::NbLines() const 
 {
 return( mImg->XSize() * mImg->YSize() );
@@ -235,5 +235,5 @@
 /* --Methode-- */
 template <class T>
-uint_4 NTupInt_Image<T>::NbColumns() const 
+sa_size_t NTupInt_Image<T>::NbColumns() const 
 {
 return(3);
@@ -242,5 +242,5 @@
 /* --Methode-- */
 template <class T>
-r_8* NTupInt_Image<T>::GetLineD(int n) const 
+r_8* NTupInt_Image<T>::GetLineD(sa_size_t n) const 
 {
 int i,j;
Index: /trunk/SophyaPI/PIext/nomimagadapter.h
===================================================================
--- /trunk/SophyaPI/PIext/nomimagadapter.h	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomimagadapter.h	(revision 2683)
@@ -53,7 +53,7 @@
 			NTupInt_Image(Image<T> * m);
   virtual		~NTupInt_Image();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
Index: /trunk/SophyaPI/PIext/nommatvecadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nommatvecadapter.cc	(revision 2682)
+++ /trunk/SophyaPI/PIext/nommatvecadapter.cc	(revision 2683)
@@ -137,5 +137,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Vector::NbLines() const
+sa_size_t NTupInt_Vector::NbLines() const
 {
 return(mVec->NElts());
@@ -143,5 +143,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Vector::NbColumns() const 
+sa_size_t NTupInt_Vector::NbColumns() const 
 {
 return(2);
@@ -149,5 +149,5 @@
 
 /* --Methode-- */
-r_8* NTupInt_Vector::GetLineD(int n) const 
+r_8* NTupInt_Vector::GetLineD(sa_size_t n) const 
 {
 int i;
@@ -302,5 +302,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Matrix::NbLines() const
+sa_size_t  NTupInt_Matrix::NbLines() const
 {
 return( mMtx->NRows()*mMtx->NCol() );
@@ -308,5 +308,5 @@
 
 /* --Methode-- */
-uint_4 NTupInt_Matrix::NbColumns() const 
+sa_size_t  NTupInt_Matrix::NbColumns() const 
 {
 return(3);
@@ -314,5 +314,5 @@
 
 /* --Methode-- */
-r_8* NTupInt_Matrix::GetLineD(int n) const 
+r_8* NTupInt_Matrix::GetLineD(sa_size_t  n) const 
 {
 int i,j;
Index: /trunk/SophyaPI/PIext/nommatvecadapter.h
===================================================================
--- /trunk/SophyaPI/PIext/nommatvecadapter.h	(revision 2682)
+++ /trunk/SophyaPI/PIext/nommatvecadapter.h	(revision 2683)
@@ -57,7 +57,7 @@
 			NTupInt_Vector(Vector* v);
   virtual		~NTupInt_Vector();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
@@ -108,7 +108,7 @@
 			NTupInt_Matrix(Matrix* m);
   virtual		~NTupInt_Matrix();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
Index: /trunk/SophyaPI/PIext/nomskymapadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomskymapadapter.cc	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomskymapadapter.cc	(revision 2683)
@@ -361,5 +361,5 @@
 /* --Methode-- */
 template <class T> 
-uint_4 NTupInt_PixelMap<T>::NbLines() const
+sa_size_t NTupInt_PixelMap<T>::NbLines() const
 {
 return( mMap->NbPixels() );
@@ -368,5 +368,5 @@
 /* --Methode-- */
 template <class T> 
-uint_4 NTupInt_PixelMap<T>::NbColumns() const 
+sa_size_t NTupInt_PixelMap<T>::NbColumns() const 
 {
 return(8);
@@ -375,5 +375,5 @@
 /* --Methode-- */
 template <class T> 
-r_8* NTupInt_PixelMap<T>::GetLineD(int n) const 
+r_8* NTupInt_PixelMap<T>::GetLineD(sa_size_t n) const 
 {
 int i;
Index: /trunk/SophyaPI/PIext/nomskymapadapter.h
===================================================================
--- /trunk/SophyaPI/PIext/nomskymapadapter.h	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomskymapadapter.h	(revision 2683)
@@ -52,7 +52,7 @@
 			NTupInt_PixelMap(PixelMap<T>* m);
   virtual		~NTupInt_PixelMap();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
Index: /trunk/SophyaPI/PIext/nomtarradapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 2683)
@@ -177,5 +177,5 @@
 /* --Methode-- */
 template <class T> 
-uint_4 NTupInt_TArray<T>::NbLines() const
+sa_size_t NTupInt_TArray<T>::NbLines() const
 {
 return( mArr->Size() );
@@ -184,5 +184,5 @@
 /* --Methode-- */
 template <class T> 
-uint_4 NTupInt_TArray<T>::NbColumns() const 
+sa_size_t NTupInt_TArray<T>::NbColumns() const 
 {
 return(11);
@@ -191,5 +191,5 @@
 /* --Methode-- */
 template <class T> 
-r_8* NTupInt_TArray<T>::GetLineD(int n) const 
+r_8* NTupInt_TArray<T>::GetLineD(sa_size_t n) const 
 {
 if ((n < 0) || (n >= (int)(mArr->Size()) ) ) {
Index: /trunk/SophyaPI/PIext/nomtarradapter.h
===================================================================
--- /trunk/SophyaPI/PIext/nomtarradapter.h	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomtarradapter.h	(revision 2683)
@@ -47,7 +47,7 @@
 			NTupInt_TArray(TArray<T>* m);
   virtual		~NTupInt_TArray();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected:
Index: /trunk/SophyaPI/PIext/nomtmatvecadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 2683)
@@ -305,5 +305,5 @@
 /* --Methode-- */
 template <class T> 
-uint_4 NTupInt_TMatrix<T>::NbLines() const
+sa_size_t NTupInt_TMatrix<T>::NbLines() const
 {
 return( mMtx->NRows()*mMtx->NCols() );
@@ -312,5 +312,5 @@
 /* --Methode-- */
 template <class T> 
-uint_4 NTupInt_TMatrix<T>::NbColumns() const 
+sa_size_t  NTupInt_TMatrix<T>::NbColumns() const 
 {
 return(8);
@@ -319,5 +319,5 @@
 /* --Methode-- */
 template <class T> 
-r_8* NTupInt_TMatrix<T>::GetLineD(int n) const 
+r_8* NTupInt_TMatrix<T>::GetLineD(sa_size_t n) const 
 {
 int i,j;
Index: /trunk/SophyaPI/PIext/nomtmatvecadapter.h
===================================================================
--- /trunk/SophyaPI/PIext/nomtmatvecadapter.h	(revision 2682)
+++ /trunk/SophyaPI/PIext/nomtmatvecadapter.h	(revision 2683)
@@ -55,7 +55,7 @@
 			NTupInt_TMatrix(TMatrix<T>* m);
   virtual		~NTupInt_TMatrix();
-  virtual uint_4        NbLines() const ;
-  virtual uint_4        NbColumns() const ;
-  virtual r_8 *         GetLineD(int n) const ;
+  virtual sa_size_t     NbLines() const ;
+  virtual sa_size_t     NbColumns() const ;
+  virtual r_8 *         GetLineD(sa_size_t n) const ;
   virtual string        VarList_C(const char* nomx=NULL) const ;
 protected: