Index: trunk/SophyaPI/PIext/nomhistadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 2690)
+++ trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 2697)
@@ -16,4 +16,6 @@
 #include "fitsntuple.h"
 #include "fitsxntuple.h"
+// Pour les DataTable ( Depuis Avril 2005 )
+#include "datatable.h"
 #endif
 
@@ -587,2 +589,83 @@
 return(mNt);
 }
+
+
+//-------------------------------------------------------------------------
+// Class Adaptateur d'objet (Pour NamedObjMgr) d'objet BaseDataTable
+//-------------------------------------------------------------------------
+
+/* --Methode-- */
+NOMAdapter_DataTable::NOMAdapter_DataTable(BaseDataTable* o)
+  : NObjMgrAdapter(o)
+{
+mDT = o;
+}
+
+/* --Methode-- */
+NOMAdapter_DataTable::~NOMAdapter_DataTable()
+{
+}
+
+/* --Methode-- */
+NObjMgrAdapter* NOMAdapter_DataTable::Clone(AnyDataObj* o)
+{
+  BaseDataTable* dt = dynamic_cast<BaseDataTable *>(o);
+  if (dt) return ( new NOMAdapter_DataTable(dt) );
+  else return ( new NObjMgrAdapter(o) );
+}
+
+/* --Methode-- */
+string NOMAdapter_DataTable::GetDataObjType()
+{
+  DataTable* dt = dynamic_cast<DataTable *>(mDT);
+  if (dt) return ("DataTable ");
+  else return  ("BaseDataTable ");
+}
+
+/* --Methode-- */
+AnyDataObj* NOMAdapter_DataTable::CloneDataObj(bool share)
+{
+  DataTable* dt = dynamic_cast<DataTable *>(mDT);
+  if (dt) return new DataTable(*dt, share);
+  else return NULL;
+}
+
+/* --Methode-- */
+void NOMAdapter_DataTable::ReadFits(string const & flnm)
+{
+  cerr << " NOMAdapter_DataTable::ReadFits() A FAIRE - Reza, Avril 2005 !! " << endl;
+}
+
+/* --Methode-- */
+void NOMAdapter_DataTable::SaveFits(string const & flnm)
+{
+  cerr << " NOMAdapter_DataTable::SaveFits() A FAIRE - Reza, Avril 2005 !! " << endl;
+}
+
+/* --Methode-- */
+void NOMAdapter_DataTable::SavePPF(POutPersist& pos, string const & nom)
+{
+  DataTable* dt = dynamic_cast<DataTable *>(mDT);
+  if (dt) { 
+    ObjFileIO<DataTable> fio(dt);
+    fio.Write(pos, nom);
+  }
+  else {
+    cerr << " NOMAdapter_DataTable::SavePPF() Objet pas de type DataTable (nom="
+	 << nom << ")" << endl;
+  }
+}
+
+/* --Methode-- */
+void NOMAdapter_DataTable::Print(ostream& os)
+{
+mDT->Show(os);
+}
+
+
+/* --Methode-- */
+NTupleInterface* NOMAdapter_DataTable::GetNTupleInterface(bool& adel)
+{
+adel = false;
+return(mDT);
+}
Index: trunk/SophyaPI/PIext/nomhistadapter.h
===================================================================
--- trunk/SophyaPI/PIext/nomhistadapter.h	(revision 2690)
+++ trunk/SophyaPI/PIext/nomhistadapter.h	(revision 2697)
@@ -14,4 +14,5 @@
 #include "ntuple.h"
 #include "xntuple.h"
+#include "basedtable.h"
 
 //-----------------------------------------------------------------------------
@@ -168,4 +169,30 @@
 };
 
+//-------------------------------------------------------------------------
+// Class Adaptateur d'objet (Pour NamedObjMgr) d'objet BaseDataTable 
+//-------------------------------------------------------------------------
+
+class NOMAdapter_DataTable : public NObjMgrAdapter {
+public:
+				NOMAdapter_DataTable(BaseDataTable* dt = NULL);
+  virtual			~NOMAdapter_DataTable();
+
+  virtual NObjMgrAdapter*	Clone(AnyDataObj* o);
+
+  virtual string		GetDataObjType();
+
+  virtual AnyDataObj*		CloneDataObj(bool share=false);
+
+  virtual void			ReadFits(string const & flnm);
+  virtual void			SaveFits(string const & flnm);
+  virtual void			SavePPF(POutPersist& s, string const & nom);
+
+  virtual void			Print(ostream& os);
+  virtual NTupleInterface*	GetNTupleInterface(bool& adel);
+
+protected:
+  BaseDataTable* mDT;
+};
+
 
 
Index: trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- trunk/SophyaPI/PIext/piinit.cc	(revision 2690)
+++ trunk/SophyaPI/PIext/piinit.cc	(revision 2697)
@@ -16,4 +16,7 @@
 #include "nomtmatvecadapter.h"
 #include "nomtarradapter.h"
+
+#include "datatable.h"
+
 #include "nomskymapadapter.h"
 #include "spherethetaphi.h"
@@ -48,5 +51,5 @@
   serv->RegisterClass(new NTuple, new NOMAdapter_NTuple );
 
-  serv->RegisterClass(new XNTuple, new NOMAdapter_XNTuple );
+  serv->RegisterClass(new DataTable, new NOMAdapter_DataTable );
   char* varenv=NULL;
   if ( (varenv=getenv("PEIDA_TMP")) == NULL )   varenv=getenv("TMPDIR") ;